'''
exec(open('singleSlopeRunup.py').read())
'''
import os
import numpy as np
import matplotlib.pyplot as plt
import matplotlib as mpl
import matplotlib.ticker as ticker
from scipy.interpolate import LinearNDInterpolator

plt.rc("font", family = "Times New Roman", size = 12.0)


class myClassCuttingPlane:
    def __init__(self, inRoot, inIndex=0, inDebug=False):

        thisDir = os.path.join(inRoot, 'dataCuttingPlane')
        thisIndex = inIndex
        inDebug and print(f'time index is {thisIndex}.')

        timeListString = sorted(os.listdir(thisDir), key=float)
        inDebug and print(timeListString)
        
        timeListLength = len(timeListString) -1
        self.timeListLength = timeListLength
        inDebug and print(timeListLength)

        if thisIndex > timeListLength:
            print("Check inIndex!")
            thisIndex = timeListLength

        thisTimeString = timeListString[thisIndex]
        thistimeScalar = float(thisTimeString)
        inDebug and print(thistimeScalar)
        self.time = thistimeScalar

        thisFile = os.path.join(thisDir, thisTimeString, 'p_yNormal.raw')
        tmpData = np.loadtxt(
                        open(thisFile, "r"),
                        # delimiter=",",
                        skiprows=2,
                        # usecols=[0, 2]
                    )
        index = -1
        index += 1; x = tmpData[:, index]        
        index += 1; y = tmpData[:, index]        
        index += 1; z = tmpData[:, index] 
        index += 1; p = tmpData[:, index] 
        self.x, self.y, self.z = x, y, z
        self.p = p

        thisFile = os.path.join(thisDir, thisTimeString, 'T_yNormal.raw')
        tmpData = np.loadtxt(
                        open(thisFile, "r"),
                        # delimiter=",",
                        skiprows=2,
                        # usecols=[0, 2]
                    )
        index = -1
        index += 1; x = tmpData[:, index]        
        index += 1; y = tmpData[:, index]        
        index += 1; z = tmpData[:, index] 
        index += 1; T = tmpData[:, index] 
        self.T = T

        thisFile = os.path.join(thisDir, thisTimeString, 'U_yNormal.raw')
        tmpData = np.loadtxt(
                        open(thisFile, "r"),
                        # delimiter=",",
                        skiprows=2,
                        # usecols=[0, 2]
                    )
        index = -1
        index += 1; x = tmpData[:, index]        
        index += 1; y = tmpData[:, index]        
        index += 1; z = tmpData[:, index] 
        index += 1; u = tmpData[:, index] 
        index += 1; v = tmpData[:, index] 
        index += 1; w = tmpData[:, index] 
        self.u, self.v, self.w = u, v, w
        self.magU = np.sqrt(u*u + v*v + w*w)
        

        

        

        
        
        
if True:

    inRoot = '../postProcessing'
    constData = myClassCuttingPlane(inRoot, inIndex=100, inDebug=True)
    

    thisDir = './'
    # = = = = + = = = = + = = = = +
    dirOut = os.path.join(thisDir, 'dataTU')
    if os.path.isdir(dirOut):
        print('OK')
    else:
        os.mkdir(dirOut)            
    # = = = = + = = = = + = = = = + 

    # if True:
    #     myDebug = True
    #     it = 999

    for it in range(constData.timeListLength):
        myDebug = False


        data100 = myClassCuttingPlane(inRoot, inIndex=it, inDebug=myDebug)



        FigureName = os.path.join(dirOut, 'time=%06.1f'%(data100.time))


        FigureNx, FigureNy = 1, 2
        FigureSize = (9, 4)


        FigureNx, FigureNy = 2, 1
        FigureSize = (9, 5.5)


        FigureNx, FigureNy = 2, 1
        FigureSize = (9, 6)

        # FigureNx, FigureNy = 1, 1
        # FigureSize = (9, 4)

        # FigureNx, FigureNy = 2, 2
        # FigureSize = (9, 6)

        # FigureNx, FigureNy = 3, 2
        # FigureSize = (9, 8)

        fig, axs = plt.subplots(ncols=FigureNy, nrows=FigureNx, 
                                figsize=FigureSize,
                                layout="constrained",
                                sharex=False, sharey=False,
                                )
        print(f'np.shape(axs) = {np.shape(axs)}')
        
        # 
        for FigureIx in range(FigureNx):
            for FigureIy in range(FigureNy):

                FigureIndex = (FigureIx -1 + 1 ) * FigureNy + FigureIy+1
                print(f'ix={FigureIx}, iy={FigureIy}, index={FigureIndex}')
                if FigureNx == FigureNy == 1:
                    myAx = axs
                elif FigureNx == 1:
                    myAx = axs[FigureIy]
                elif FigureNy == 1:
                    myAx = axs[FigureIx]
                else:
                    myAx = axs[FigureIx, FigureIy]
                
                myAx.grid()

                # textLabelX = "X (m)"
                # textLabelY = "Y (m)"  
                # data involking
                if FigureIndex <= 20:
                    if FigureIndex == 1:                                     
                        textLabelX = "x (m)"
                        textLabelY = "z (m)"  
                        myAx.set_aspect(1)
                        myAx.set_aspect(1.0)

                        tmpData = data100
                        
                        tmp_x = tmpData.x
                        tmp_y = tmpData.z
                        tmp_z = tmpData.T
                        print(np.min(tmp_z))
                        print(np.max(tmp_z))

                        textTitle = f'({FigureIndex}): Tenperature distribution, time={tmpData.time}'
                            
                        
                        tmp_level = np.linspace(300, 305.0, 1+10)
                        colorBarNum = 10
                        myAx.set_title(textTitle, loc = "left")

                        CS = myAx.tricontourf(tmp_x, tmp_y, tmp_z,
                            cmap = "jet",
                            levels=tmp_level,
                            extend = "both",
                        )

                        tttLevels = [300.5, ]
                        CS1 = myAx.tricontour(tmp_x, tmp_y, tmp_z, 
                                        tttLevels, colors=('black',), linewidths=(1.5,))
                        myAx.clabel(CS1, fmt='%2.2f', colors='black', fontsize=14)

                        cbar = fig.colorbar(CS,
                                    ax= myAx,
                                    ticks = np.linspace(tmp_level.min(), tmp_level.max(), 1+colorBarNum, endpoint=True),
                                    shrink = 0.75, aspect = 20
                            )
                        cbar.set_label('Temperature (K)', labelpad=1)
                    # 
                    if FigureIndex == 2:
                        textLabelX = "x (m)"
                        textLabelY = "z (m)"  
                        myAx.set_aspect(1)
                        myAx.set_aspect(1.0)

                        tmpData = data100
                        
                        tmp_x = tmpData.x
                        tmp_y = tmpData.z
                        tmp_z = tmpData.magU
                        print(np.min(tmp_z))
                        print(np.max(tmp_z))


                        textTitle = f'({FigureIndex}): Velocity distribution, time={tmpData.time}'
                            
                        
                        tmp_level = np.linspace(0, 0.5, 1+10)
                        colorBarNum = 10
                        myAx.set_title(textTitle, loc = "left")

                        CS = myAx.tricontourf(tmp_x, tmp_y, tmp_z,
                            cmap = "jet",
                            levels=tmp_level,
                            extend = "both",
                        )

                        tttLevels = [.1, ]
                        CS1 = myAx.tricontour(tmp_x, tmp_y, tmp_z, 
                                        tttLevels, colors=('black',), linewidths=(1.5,))
                        myAx.clabel(CS1, fmt='%2.2f', colors='black', fontsize=14)

                        cbar = fig.colorbar(CS,
                                    ax= myAx,
                                    ticks = np.linspace(tmp_level.min(), tmp_level.max(), 1+colorBarNum, endpoint=True),
                                    shrink = 0.75, aspect = 20
                            )
                        cbar.set_label('Velocity (m/s)', labelpad=1)
                    # 

                    if False:
                        FigureXmin, FigureXmax = np.min(tmp_x), np.max(tmp_x)
                        FigureYmin, FigureYmax = np.min(tmp_y), np.max(tmp_y)
                        FigureTickXN = 10
                        FigureTickYN = 10
                        FigureDx = (FigureXmax - FigureXmin) / FigureTickXN
                        FigureDy = (FigureYmax - FigureYmin) / FigureTickYN
                    elif FigureIndex in [1, 2, 3]:
                        FigureXmin, FigureXmax = -100, 100
                        FigureYmin, FigureYmax = 0, 50

                        FigureTickXN = 10
                        FigureTickYN = 5
                        FigureDx = (FigureXmax - FigureXmin) / FigureTickXN
                        FigureDy = (FigureYmax - FigureYmin) / FigureTickYN


                    # end

                
                    
                

                # * * * * + * * * * + * * * * + * * * * + * * * * + * * * * + * * * * +
                # myAx.legend(
                #     markerscale = 1.0,
                #     loc = "upper right",
                #     fontsize = "small",
                #     edgecolor = "black",
                #     facecolor = "white",
                #     ncol = 1,
                #     # title = "Velocity CDF",
                # )

                
                '''
                    WARN: following lines can not be modified, if YOU know how to do them.
                '''
                # - - - - + - - - - + - - - - + - - - - + - - - - + - - - - + - - - - +
                myAx.set_xlim(FigureXmin, FigureXmax)
                FigureTickX = np.linspace(FigureXmin, FigureXmax, num=FigureTickXN+1)
                # print(f'FigureTickX = {FigureTickX}')
                myAx.set_xticks(FigureTickX)
                FigureTickXLabel = ['%04d'%i for i in FigureTickX] if np.mod(FigureDx,1) == 0 else ['%.1f'%i for i in FigureTickX]
                # myAx.set_xticklabels(FigureTickXLabel)
                if FigureIy == 1-1 or True:
                    myAx.set_ylabel(textLabelY)
                # end

                myAx.set_ylim(FigureYmin, FigureYmax)
                FigureTickY = np.linspace(FigureYmin, FigureYmax, num=FigureTickYN+1)
                myAx.set_yticks(FigureTickY)
                FigureTickYLabel = ['%04d'%i for i in FigureTickY] if np.mod(FigureDy,1) == 0 else ['%.1f'%i for i in FigureTickY]
                # myAx.set_yticklabels(FigureTickYLabel)
                if FigureIx == FigureNx-1 or True:
                    myAx.set_xlabel(textLabelX)
                # end
                # - - - - + - - - - + - - - - + - - - - + - - - - + - - - - + - - - - +
                
                
        # plt.tight_layout()
        plt.savefig(f'{FigureName}.png', bbox_inches='tight',dpi=400)
        # plt.savefig(f'{FigureName}.pdf', bbox_inches='tight')
        if myDebug:
            plt.show()
    # end

