'''
exec(open('png2gif.py').read())
'''

# from myClass import png2gif, png2mp4

### ======================= 使用imageio包将图片转GIF ======================== ###
import os
import numpy as np
import imageio.v2 as imageio

import imageio
from PIL import Image

def png2gif(inDir, outFileName):
    # 需要转GIF的图片路径
    path = inDir
    img_lst = os.listdir(path)
    img_lst = sorted(
            [x for x in img_lst if x.endswith('.png')]
        )
    img_lst = sorted(img_lst,reverse=False)
    
    frames = []
    for img in img_lst:
        frames.append(imageio.imread(path + img))
    # duration是保存一帧图片的时间，其实就是相当于帧率。使用imageio方法来resize图像还没找到
    imageio.mimsave(f"{outFileName}.gif", frames, 'GIF', duration=0.033)


def png2mp4(inDir, outFileName, inFPS=30):
    
    # 读取所有 PNG 图片
    images = []
    for file_name in sorted(os.listdir(inDir)):
        if file_name.endswith('.png'):
            images.append(Image.open(os.path.join(inDir, file_name)))

    # 将图片转换为视频
    for fps in inFPS:  # 每秒钟30帧, pip install imageio[ffmpeg] imageio[pyav]
        filename = f'{outFileName}-fps{fps}.mp4'
        with imageio.get_writer(filename, fps=fps) as video:
            for image in images:
                frame = image.convert('RGB')
                video.append_data(np.array(frame))
                

        




if True:
    outFileName = 'dataTU'
    inDir = './dataTU'
    png2mp4(inDir, outFileName, inFPS=[10, 20, 30])


